(*********************************************************************)
(*      DEMO.PML  > DEMO.PAS                                         *)
(*********************************************************************)
(*********************************************************************)
PROGRAM Demo;
(*********************************************************************)
##DEF_MEGALOCK_CALL 16BIT
##DEF_MEGALOCK_MACRO
Var
(*********************************************************************)
Status  : Integer;
(*********************************************************************)
PROCEDURE Example2;
Var
  CounterReg : WORD;
  RDataReg   : WORD;
  StrTab     : Array [1..32] of CHAR;
Begin
  ML..PROGNO=0
  ML..ACount(0,CounterReg%)
      Writeln('Inhalt Counterstand(0) = ',CounterReg);
      StrTab := 'Kryptieren knnen alle, wir auch';
  ML..CLock(0,32,StrTab$)
      Writeln('String crypt           = ',StrTab);
  ML..CLock(0,32,StrTab$)
      Writeln('String decrypt         = ',StrTab);
  ML..RData(0,RDataReg%)
      Writeln('Inhalt DataTab(0)      = ',RDataReg);
End;
(*********************************************************************)
PROCEDURE Example3;
Var
  a,b : LONGINT;
Begin
##BEGIN
  MODUL=EXAMPLE3
  PROGNO=0,MODULNR=1
  NOTURBO,NOREADCT,NOWATCHDOG,STATUS=Status
  LONG a,b

  mclr
  Move (LR1,100)
  Move (LR2,1)
  Move (LR3,3)

  for  (LR4 = 0; LR4 < LR3; LR4 += 1 )
    if LR4 < 2
      Addition (LR1,LR4)
    else
      Subtract (LR2,LR1)
    endif
  next

  Clear(LR1)
  Move (LR0,50)
  do
    Addition (LR1,a)
    Increment (LR2)

    if LR1 > b
      Move (LR0,1)
      Getreg (a,LR1)
    endif
  loop LR0
##END
End;
(*********************************************************************)
Begin
(*********************************************************************)
  Status := ##OPEN_MEGALOCK(0)
  if Status = 0 then
  begin
    Writeln('Hello Word I have found the MEGALOCK dongle');
    Example2;
    Example3;
    ##CLOSE_MEGALOCK(0)
  end
  else
    Writeln('No Dongle present, Status = ',Status);
(*********************************************************************)
End.
