(*********************************************************************)
(*      DEMO.SML  > DEMO.PAS                                         *)
(*********************************************************************)
unit Demo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
##DEF_MEGALOCK_CALL 16BIT
(*********************************************************************)
##DEF_MEGALOCK_MACRO
(*********************************************************************)
type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Example2(Sender: TObject);
    procedure Example3(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
(*********************************************************************)
var
Form1   : TForm1;
Status  : Integer;
(*********************************************************************)
implementation
(*********************************************************************)
{$R *.DFM}
(*********************************************************************)
PROCEDURE TForm1.Example2(Sender: TObject);
Var
  CounterReg : WORD;
  RDataReg   : WORD;
  StrTab     : Array [1..32] of CHAR;
  i          : Integer;
Begin
  ML..PROGNO=0
  ML..ACount(0,CounterReg%)
      Edit2.Text := IntToStr(CounterReg);
      StrTab     := 'Kryptieren knnen alle, wir auch';
  ML..CLock(0,32,StrTab$)
      for i:=1 to 32 do
        if StrTab[i] < '' then StrTab[i] := '.';
      Edit3.Text := StrTab;
  ML..CLock(0,32,StrTab$)
      Edit4.Text := StrTab;
  ML..RData(0,RDataReg%)
      Edit5.Text := IntToStr(RDataReg);
End;
(*********************************************************************)
PROCEDURE TForm1.Example3(Sender: TObject);
Var
  a,b : LONGINT;
Begin
##BEGIN
  MODUL=EXAMPLE3
  PROGNO=0,MODULNR=1
  NOTURBO,NOREADCT,NOWATCHDOG,STATUS=Status
  LONG a,b

  mclr
  Move (LR1,100)
  Move (LR2,1)
  Move (LR3,3)

  for  (LR4 = 0; LR4 < LR3; LR4 += 1 )
    if LR4 < 2
      Addition (LR1,LR4)
    else
      Subtract (LR2,LR1)
    endif
  next

  Clear(LR1)
  Move (LR0,50)
  do
    Addition (LR1,a)
    Increment (LR2)

    if LR1 > b
      Move (LR0,1)
      Getreg (a,LR1)
    endif
  loop LR0
##END
End;
(*********************************************************************)
procedure TForm1.Button2Click(Sender: TObject);
begin
Halt(0);    {* EXIT Button *}
end;
(*********************************************************************)
procedure TForm1.Button1Click(Sender: TObject);
begin
  Edit1.Text := ' ';
  Edit2.Text := ' ';
  Edit3.Text := ' ';
  Edit4.Text := ' ';
  Edit5.Text := ' ';
  Status := ##OPEN_MEGALOCK(0)
  if Status = 0 then
  begin
    Edit1.Text := 'Hello Word I have found the MEGALOCK dongle';
    Example2(Sender);
    Example3(Sender);
    ##CLOSE_MEGALOCK(0)
  end
  else
    Edit1.Text := 'No Dongle present, Status = ' +IntToStr(Status);
(*********************************************************************)
end; {of procedure }
(*********************************************************************)
end.
(*********************************************************************)
