/********************************************************************/
/*                       MEGALOCK                                   */
/********************************************************************/
/* Source file input : DEMO.SML                                     */
/* Source file output: DEMO.C                                       */
/********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/********************************************************************/
void EXAMPLE2(void);
void EXAMPLE3(void);
/********************************************************************/
/*Declaration and definition */

##DEF_MEGALOCK_MACRO
##DEF_MEGALOCK_CALL 32BIT
/********************************************************************/
/* Programcode  */

main()
{
  short a;

  a = ##OPEN_MEGALOCK(0)
  if (a == 0)
  {
   printf ("\n\nHello World I have found the MEGALOCK dongle");
   EXAMPLE2();
   EXAMPLE3();
   ##CLOSE_MEGALOCK(0)
  }
  else
   printf("\nNo Dongle present, Status = %d", a);
  return(0);
}
/********************************************************************/
void EXAMPLE2()
{
ushort CounterReg, RDataReg;
char StrTab[33];

   ML..PROGNO=0
   ML..ACount(0,CounterReg%)
       printf ("\n\nInhalt CounterTab(0) = %u\n", CounterReg);

   strcpy (StrTab,"Kryptieren knnen alle, wir auch");
   ML..CLock(0,32,StrTab$)
       printf ("\nString crypt         = %s", StrTab);
   ML..CLock(0,32,StrTab$)
       printf ("\nString decrypt       = %s", StrTab);

   ML..RData(0,RDataReg%)
       printf ("\n\nInhalt DataTab(0)    = %u", RDataReg);

 }
/********************************************************************/
void EXAMPLE3()
{
  ushort Status;
  ulong  a,b;

##BEGIN
  MODUL=DEMO_EXAMPLE3
  PROGNO=0,MODULNR=1
  NOTURBO,NOREADCT,NOWATCHDOG,STATUS=Status
  LONG a,b

  mclr
  Move (LR1,100)
  Move (LR2,1)
  Move (LR3,3)

  for  (LR4 = 0; LR4 < LR3; LR4 += 1 )
    if LR4 < 2
      Addition (LR1,LR4)
    else
      Subtract (LR2,LR1)
    endif
  next

  Clear(LR1)
  Move (LR0,50)
  do
    Addition (LR1,a)
    Increment (LR2)

    if LR1 > b
      Move (LR0,1)
      Getreg (a,LR1)
    endif
  loop LR0
##END
}
/********************************************************************/
