/********************************************************************/
/*                       MEGALOCK                                   */
/********************************************************************/
/* Source file input : DEMO.SML                                     */
/* Source file output: DEMO.C                                       */
/********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/********************************************************************/
void EXAMPLE2(void);
void EXAMPLE3(void);
/********************************************************************/
/*Declaration and definition */

/* ##DEF_MEGALOCK_MACRO */
#define ushort unsigned short
#define ulong  unsigned long
/* ##DEF_MEGALOCK_CALL 32BIT */
/********************************************************************/
extern "C" void _stdcall MEGALOCK1(ulong OpCode);
extern "C" void _stdcall MEGALOCK2(ulong OpCode,ushort wdat1);
extern "C" void _stdcall MEGALOCK3(ulong OpCode,ulong ldat1);
extern "C" void _stdcall MEGALOCK4(ulong OpCode,ushort *wptr);
extern "C" void _stdcall MEGALOCK5(ulong OpCode,ulong *lptr);
extern "C" void _stdcall MEGALOCK6(ulong OpCode,char *sptr);
extern "C" void _stdcall MEGALOCK7(ulong OpCode,ushort *wptr,ushort wdat1);
extern "C" void _stdcall MEGALOCK8(ulong OpCode,ulong *lptr,ushort wdat1);
extern "C" void _stdcall MEGALOCK9(ulong OpCode,char *sptr,ushort wdat1);
extern "C" int _stdcall  MEGALOCK10(ulong OpCode);
extern "C" int _stdcall  MEGALOCK11(ulong OpCode,ulong ldat1);
/********************************************************************/
/* Programcode  */

main()
{
  short a;

/*   a = ##OPEN_MEGALOCK(0) */
  a = MEGALOCK11(0x11800000L,0x01c9f600L);
  if (a == 0)
  {
   printf ("\n\nHello World I have found the MEGALOCK dongle");
   EXAMPLE2();
   EXAMPLE3();
/*    ##CLOSE_MEGALOCK(0) */
   MEGALOCK1(0x20800000L);
  }
  else
   printf("\nNo Dongle present, Status = %d", a);
   return(0);
}
/********************************************************************/
void EXAMPLE2()
{
ushort CounterReg, RDataReg;
char StrTab[33];

/*    ML..PROGNO=0 */

/*    ML..ACount(0,CounterReg%) */
   MEGALOCK4(0x1000865aL,&CounterReg);
       printf ("\n\nInhalt CounterTab(0) = %u\n", CounterReg);

   strcpy (StrTab,"Kryptieren knnen alle, wir auch");
/*    ML..CLock(0,32,StrTab$) */
   MEGALOCK9(0x00000950L,(char *)StrTab,0x0020);
       printf ("\nString crypt         = %s", StrTab);
/*    ML..CLock(0,32,StrTab$) */
   MEGALOCK9(0x00000950L,(char *)StrTab,0x0020);
       printf ("\nString decrypt       = %s", StrTab);

/*    ML..RData(0,RDataReg%) */
   MEGALOCK4(0x1000e2f5L,&RDataReg);
       printf ("\n\nInhalt DataTab(0)    = %u", RDataReg);

 }
/********************************************************************/
void EXAMPLE3()
{
  ushort Status;
  ulong  a,b;

/* ##BEGIN */
/*   MODUL=DEMO_EXAMPLE3 */
/*   PROGNO=0,MODULNR=1 */
/*   NOTURBO,NOREADCT,NOWATCHDOG,STATUS=Status */
/*   LONG a,b */
/*  */
/*   mclr */
  if (MEGALOCK11(0x020022c9L,0x00005bffL) == -1)
  {
    MEGALOCK1(0x0040c8d9L);
/*   Move (LR1,100) */
    MEGALOCK3(0x02402c3bL,0x00000064L);
/*   Move (LR2,1) */
    MEGALOCK1(0x004055afL);
/*   Move (LR3,3) */
    MEGALOCK1(0x004099d0L);
/*  */
/*   for  (LR4 = 0; LR4 < LR3; LR4 += 1 ) */
    MEGALOCK3(0x0240ca4bL,0x00000000L);
    for (;;)
    {
      MEGALOCK1(0x0040e65dL);
      if (MEGALOCK10(0x00402378L) != -1) break;
/*     if LR4 < 2 */
      MEGALOCK1(0x0040bc86L);
      if (MEGALOCK10(0x00402378L) == -1)
      {
/*       Addition (LR1,LR4) */
        MEGALOCK1(0x004073f1L);
/*     else */

      } else
      {
/*       Subtract (LR2,LR1) */
        MEGALOCK1(0x0040b096L);
/*     endif */
      }
/*   next */
      MEGALOCK1(0x0040b162L);
    }
/*  */
/*   Clear(LR1) */
    MEGALOCK1(0x0040799bL);
/*   Move (LR0,50) */
    MEGALOCK3(0x02401fe0L,0x00000032L);
/*   do */
    for (;;)  
    {
/*     Addition (LR1,a) */
      MEGALOCK3(0x0240d737L,a);
/*     Increment (LR2) */
      MEGALOCK1(0x0040c6c6L);
/*  */
/*     if LR1 > b */
      MEGALOCK3(0x02401e7eL,b);
      if (MEGALOCK10(0x00404bdaL) == -1)
      {
/*       Move (LR0,1) */
        MEGALOCK1(0x00408133L);
/*       Getreg (a,LR1) */
        MEGALOCK5(0x20401aacL,&a);
/*     endif */
      }
/*   loop LR0 */
      MEGALOCK1(0x00407da9L);
      MEGALOCK3(0x0240f5dcL,0x00000000L);
      if (MEGALOCK10(0x004040c6L) != -1) break;
    }
    MEGALOCK1(0x00402c26L);
  }
  MEGALOCK4(0x30800000L,&Status);
/* ##END */
} 
/********************************************************************/
