/********************************************************************/
/*                       MEGALOCK                                   */
/********************************************************************/
/* Source file input : DEMO.SML                                     */
/* Source file output: DEMO.DLL                                     */
/********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <stdafx.h>
#include <wchar.h>
#include "DemoDLL.h"
/********************************************************************/
void EXAMPLE2(void);
void EXAMPLE3(void);
/********************************************************************/
/*Declaration and definition */

##DEF_MEGALOCK_MACRO
##DEF_MEGALOCK_CALL 32BIT
//####################################################################
//####################################################################
DEFINE_PROPERTY(Plugin_Name,L"Demo"); 
DEFINE_PROPERTY(Plugin_Version,L"01.00.0000");
DEFINE_PROPERTY(Plugin_Author,L"Megalock"); 
DEFINE_PROPERTY(Plugin_Description,L"Example plugin to Megalock-Dongle");
//####################################################################/
IMPLEMENT_PLUGIN(CDemoDLL)
int NoDongle = TRUE;
//####################################################################
/* Programcode  */
CDemoDLL::CDemoDLL()
{
  NoDongle = ##OPEN_MEGALOCK(0)
}
//####################################################################
CDemoDLL::~CDemoDLL()
{
   ##CLOSE_MEGALOCK(0)	
}
//###################################################################
//###################################################################

/********************************************************************/
DECLARE_PARAMETERS(CDemoDLL, EXAMPLE2, L"Tell SWF Studio about an FTP.transfer event that you'd like to receive notifications for.");
	OUT_PARAMETER(s1, L"String CounterTab");
	OUT_PARAMETER(s2, L"String Crypt");
	OUT_PARAMETER(s3, L"String Decrypt");
	OUT_PARAMETER(s4, L"String DataTab");
	ERROR_CODE(1, L"Megalock Dongle not open");
END_PARAMETERS;

IMPLEMENT_COMMAND(CDemoDLL, EXAMPLE2)
{
ushort  CounterReg, RDataReg;
char 	StrTab[33];
wchar_t ws[100];

   if (NoDongle)
	return(1);

   ML..PROGNO=0
   ML..ACount(0,CounterReg%)
       	swprintf(ws,L"Inhalt CounterTab(0) = %u", CounterReg);
       	pNCCommandParameters->SetParameter(L"s1",ws);

   strcpy (StrTab,"Kryptieren koennen alle, wir auch");
   ML..CLock(0,32,StrTab$)
	swprintf(ws,L"String crypt         = %s", StrTab);
	pNCCommandParameters->SetParameter(L"s2",ws);

   ML..CLock(0,32,StrTab$)
        swprintf(ws,L"String decrypt       = %s", StrTab);
	pNCCommandParameters->SetParameter(L"s3",ws);

   ML..RData(0,RDataReg%)
        swprintf(ws, L"Inhalt DataTab(0)    = %u", RDataReg);
	pNCCommandParameters->SetParameter(L"s4",ws);

   return(S_OK);

 }
/********************************************************************/
DECLARE_PARAMETERS(CDemoDLL, EXAMPLE3, L"Tell SWF Studio about an FTP.transfer event that you'd like to receive notifications for.");
	IN_PARAMETER(ivar_a, L"Variable a", L"3");
	IN_PARAMETER(ivar_b, L"Variable b", L"10");
	OUT_PARAMETER(ovar_a, L"Register LR1");
	OUT_PARAMETER(status, L"Megalock Status");
	ERROR_CODE(1, L"Megalock Dongle not open or Error");
END_PARAMETERS;
IMPLEMENT_COMMAND(CDemoDLL, EXAMPLE3)
{
  ushort 	Status;
  ulong  	a,b;
  LPCWSTR 	inParm;

  if (NoDongle)
     return(1);

  inParm = pNCCommandParameters->GetParameter(L"var_a");
  a = _wtoi(inParm);
  inParm = pNCCommandParameters->GetParameter(L"var_b");
  b = _wtoi(inParm);

##BEGIN
  MODUL=DEMO_EXAMPLE3
  PROGNO=0,MODULNR=1
  NOTURBO,NOREADCT,NOWATCHDOG,STATUS=Status
  LONG a,b

  Move (LR1,100)
  Move (LR2,1)
  Move (LR3,3)

 
  for  (LR4 = 0; LR4 < LR3; LR4 += 1 )
    if LR4 < 2
      Addition (LR1,LR4)
    else
      Subtract (LR2,LR1)
    endif
  next

  Clear(LR1)
  Move (LR0,50)
  do
    Addition (LR1,a)
    Increment (LR2)

    if LR1 > b
      Move (LR0,1)
      Getreg (a,LR1)
    endif
  loop LR0
##END

  pNCCommandParameters->SetParameter(L"ovar_a",(int)a);
  pNCCommandParameters->SetParameter(L"status",Status);

  if (Status)
    return(1);
  return(S_OK);
}
/********************************************************************/
