/********************************************************************/
/*                       MEGALOCK-Clipper                           */
/********************************************************************/
/* Source file input : DEMO.SML                                     */
/* Source file output: DEMO.PRG                                     */
/********************************************************************/
/********************************************************************/
/*Declaration and definition */

##DEF_MEGALOCK_MACRO
##DEF_MEGALOCK_CALL 16BIT
/********************************************************************/
/* Programcode  */

FUNCTION Main ()
  LOCAL a := 1

  a = ##OPEN_MEGALOCK(0)
  IF  a == 0
    ? "Hello World I have found the MEGALOCK dongle"
    EXAMPLE2()
    EXAMPLE3()
    ##CLOSE_MEGALOCK(0)
  ELSE
    ?  "No Dongle present, Status = " + STR(a)
  ENDIF
RETURN(NIL);

/********************************************************************/
FUNCTION EXAMPLE2 ()
LOCAL  CounterReg := 0
LOCAL  RDataReg   := 0
LOCAL  StrTab     := ""

   ML..PROGNO=0
   ML..ACount(0,CounterReg%)
       ? "Inhalt CounterTab(0) = " +STR(CounterReg)

       StrTab = "Kryptieren knnen alle, wir auch"
   ML..CLock(0,32,StrTab$)
       ? "String crypt         = " + StrTab
   ML..CLock(0,32,StrTab$)
       ? "String decrypt       = " + StrTab

   ML..RData(0,RDataReg%)
       ? "Inhalt DataTab(0)    = " +STR(RDataReg)

RETURN(NIL)
/********************************************************************/
FUNCTION EXAMPLE3 ()
LOCAL  Status := 0
LOCAL  a      := 0
LOCAL  b      := 0

##BEGIN
  MODUL=DEMO_EXAMPLE3
  PROGNO=0,MODULNR=1
  NOTURBO,NOREADCT,NOWATCHDOG,STATUS=Status
  LONG a,b

  mclr
  Move (LR1,100)
  Move (LR2,1)
  Move (LR3,3)

  for  (LR4 = 0; LR4 < LR3; LR4 += 1 )
    if LR4 < 2
      Addition (LR1,LR4)
    else
      Subtract (LR2,LR1)
    endif
  next

  Clear(LR1)
  Move (LR0,50)
  do
    Addition (LR1,a)
    Increment (LR2)

    if LR1 > b
      Move (LR0,1)
      Getreg (a,LR1)
    endif
  loop LR0
##END
RETURN(NIL)
/********************************************************************/
