/********************************************************************/
/*                       MEGALOCK                                   */
/********************************************************************/
/* Source file input : DEMO.SML                                     */
/* Source file output: DEMO.DLL                                     */
/********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <stdafx.h>
#include <wchar.h>
#include "DemoDLL.h"
/********************************************************************/
void EXAMPLE2(void);
void EXAMPLE3(void);
/********************************************************************/
/*Declaration and definition */

/* ##DEF_MEGALOCK_MACRO */
#define ushort unsigned short
#define ulong  unsigned long
/* ##DEF_MEGALOCK_CALL 32BIT */
extern "C" void  _stdcall MEGALOCK1(ulong OpCode);
extern "C" void _stdcall MEGALOCK2(ulong OpCode,ushort wdat1);
extern "C" void _stdcall MEGALOCK3(ulong OpCode,ulong ldat1);
extern "C" void _stdcall MEGALOCK4(ulong OpCode,ushort  *wptr);
extern "C" void _stdcall MEGALOCK5(ulong OpCode,ulong  *lptr);
extern "C" void _stdcall MEGALOCK6(ulong OpCode,char  *sptr);
extern "C" void _stdcall MEGALOCK7(ulong OpCode,ushort  *wptr,ushort wdat1);
extern "C" void _stdcall MEGALOCK8(ulong OpCode,ulong  *lptr,ushort wdat1);
extern "C" void _stdcall MEGALOCK9(ulong OpCode,char  *sptr,ushort wdat1);
extern "C" int _stdcall MEGALOCK10(ulong OpCode);
extern "C" int _stdcall MEGALOCK11(ulong OpCode,ulong ldat1);
//####################################################################
//####################################################################
DEFINE_PROPERTY(Plugin_Name,L"Demo"); 
DEFINE_PROPERTY(Plugin_Version,L"01.00.0000");
DEFINE_PROPERTY(Plugin_Author,L"Megalock"); 
DEFINE_PROPERTY(Plugin_Description,L"Example plugin to Megalock-Dongle");
//####################################################################/
IMPLEMENT_PLUGIN(CDemoDLL)
int NoDongle = TRUE;
//####################################################################
/* Programcode  */
CDemoDLL::CDemoDLL()
{
/*   NoDongle = ##OPEN_MEGALOCK(0) */
  NoDongle = MEGALOCK11(0x11800000L,0x01c9f600L);
}
//####################################################################
CDemoDLL::~CDemoDLL()
{
/*    ##CLOSE_MEGALOCK(0)	 */
   MEGALOCK1(0x20800000L);
}
//###################################################################
//###################################################################

/********************************************************************/
DECLARE_PARAMETERS(CDemoDLL, EXAMPLE2, L"Tell SWF Studio about an FTP.transfer event that you'd like to receive notifications for.");
	OUT_PARAMETER(s1, L"String CounterTab");
	OUT_PARAMETER(s2, L"String Crypt");
	OUT_PARAMETER(s3, L"String Decrypt");
	OUT_PARAMETER(s4, L"String DataTab");
	ERROR_CODE(1, L"Megalock Dongle not open");
END_PARAMETERS;

IMPLEMENT_COMMAND(CDemoDLL, EXAMPLE2)
{
ushort  CounterReg, RDataReg;
char 	StrTab[33];
wchar_t ws[100];

   if (NoDongle)
	return(1);

/*    ML..PROGNO=0 */
   
/*    ML..ACount(0,CounterReg%) */
   MEGALOCK4(0x1000865aL,&CounterReg);
       	swprintf(ws,L"Inhalt CounterTab(0) = %u", CounterReg);
       	pNCCommandParameters->SetParameter(L"s1",ws);

   strcpy (StrTab,"Kryptieren koennen alle, wir auch");
/*    ML..CLock(0,32,StrTab$) */
   MEGALOCK9(0x00000950L,(char *)StrTab,0x0020);
	swprintf(ws,L"String crypt         = %s", StrTab);
	pNCCommandParameters->SetParameter(L"s2",ws);

/*    ML..CLock(0,32,StrTab$) */
   MEGALOCK9(0x00000950L,(char *)StrTab,0x0020);
        swprintf(ws,L"String decrypt       = %s", StrTab);
	pNCCommandParameters->SetParameter(L"s3",ws);

/*    ML..RData(0,RDataReg%) */
   MEGALOCK4(0x1000e2f5L,&RDataReg);
        swprintf(ws, L"Inhalt DataTab(0)    = %u", RDataReg);
	pNCCommandParameters->SetParameter(L"s4",ws);

   return(S_OK);

 }
/********************************************************************/
DECLARE_PARAMETERS(CDemoDLL, EXAMPLE3, L"Tell SWF Studio about an FTP.transfer event that you'd like to receive notifications for.");
	IN_PARAMETER(ivar_a, L"Variable a", L"3");
	IN_PARAMETER(ivar_b, L"Variable b", L"10");
	OUT_PARAMETER(ovar_a, L"Register LR1");
	OUT_PARAMETER(status, L"Megalock Status");
	ERROR_CODE(1, L"Megalock Dongle not open or Error");
END_PARAMETERS;
IMPLEMENT_COMMAND(CDemoDLL, EXAMPLE3)
{
  ushort 	Status;
  ulong  	a,b;
  LPCWSTR 	inParm;

  if (NoDongle)
     return(1);

  inParm = pNCCommandParameters->GetParameter(L"var_a");
  a = _wtoi(inParm);
  inParm = pNCCommandParameters->GetParameter(L"var_b");
  b = _wtoi(inParm);

  if (MEGALOCK11(0x020022c9L,0x0000bf1bL) == -1)
  {
    MEGALOCK3(0x02402c3bL,0x00000064L);
/*   Move (LR2,1) */
    MEGALOCK1(0x004055afL);
/*   Move (LR3,3) */
    MEGALOCK1(0x004099d0L);
/*  */
/*   */
/*   for  (LR4 = 0; LR4 < LR3; LR4 += 1 ) */
    MEGALOCK3(0x0240ca4bL,0x00000000L);
    for (;;)
    {
      MEGALOCK1(0x0040e65dL);
      if (MEGALOCK10(0x00402378L) != -1) break;
/*     if LR4 < 2 */
      MEGALOCK1(0x0040bc86L);
      if (MEGALOCK10(0x00402378L) == -1)
      {
/*       Addition (LR1,LR4) */
        MEGALOCK1(0x004073f1L);
/*     else */

      } else
      {
/*       Subtract (LR2,LR1) */
        MEGALOCK1(0x0040b096L);
/*     endif */
      }
/*   next */
      MEGALOCK1(0x0040b162L);
    }
/*  */
/*   Clear(LR1) */
    MEGALOCK1(0x0040799bL);
/*   Move (LR0,50) */
    MEGALOCK3(0x02401fe0L,0x00000032L);
/*   do */
    for (;;)
    {
/*     Addition (LR1,a) */
      MEGALOCK3(0x0240d737L,a);
/*     Increment (LR2) */
      MEGALOCK1(0x0040c6c6L);
/*  */
/*     if LR1 > b */
      MEGALOCK3(0x02401e7eL,b);
      if (MEGALOCK10(0x00404bdaL) == -1)
      {
/*       Move (LR0,1) */
        MEGALOCK1(0x00408133L);
/*       Getreg (a,LR1) */
        MEGALOCK5(0x20401aacL,&a);
/*     endif */
      }
/*   loop LR0 */
      MEGALOCK1(0x00407da9L);
      MEGALOCK3(0x0240f5dcL,0x00000000L);
      if (MEGALOCK10(0x004040c6L) != -1) break;
    }
    MEGALOCK1(0x00402c26L);
  }
  MEGALOCK4(0x30800000L,&Status);
/* ##END */

  pNCCommandParameters->SetParameter(L"ovar_a",(int)a);
  pNCCommandParameters->SetParameter(L"status",Status);

  if (Status)
    return(1);
  return(S_OK);
}
/********************************************************************/
