/********************************************************************/
/*                       MEGALOCK-Clipper                           */
/********************************************************************/
/* Source file input : DEMO.SML                                     */
/* Source file output: DEMO.PRG                                     */
/********************************************************************/
/********************************************************************/
/*Declaration and definition */

/* ##DEF_MEGALOCK_MACRO */
/* ##DEF_MEGALOCK_CALL 16BIT */
/********************************************************************/
/* Programcode  */

FUNCTION Main ()
  LOCAL a := 0

/*   a = ##OPEN_MEGALOCK(0) */
  a = MEGALOCK0(293601280,30012928) 
  IF  a == 0
    ? "Hello World I have found the MEGALOCK dongle"
    EXAMPLE2()
    EXAMPLE3()
/*     ##CLOSE_MEGALOCK(0) */
    MEGALOCK0(545259520) 
  ELSE
    ?  "No Dongle present, Status = " + STR(a)
  ENDIF
RETURN(NIL);

/********************************************************************/
FUNCTION EXAMPLE2 ()
LOCAL  CounterReg := 0
LOCAL  RDataReg   := 0
LOCAL  StrTab     := ""

/*    ML..PROGNO=0 */
   
/*    ML..ACount(0,CounterReg%) */
   MEGALOCK0(268469850,@CounterReg) 
       ? "Inhalt CounterTab(0) = " +STR(CounterReg)

       StrTab = "Kryptieren knnen alle, wir auch"
/*    ML..CLock(0,32,StrTab$) */
   MEGALOCK0(2384,@StrTab,32) 
       ? "String crypt         = " + StrTab
/*    ML..CLock(0,32,StrTab$) */
   MEGALOCK0(2384,@StrTab,32) 
       ? "String decrypt       = " + StrTab

/*    ML..RData(0,RDataReg%) */
   MEGALOCK0(268493557,@RDataReg) 
       ? "Inhalt DataTab(0)    = " +STR(RDataReg)

RETURN(NIL)
/********************************************************************/
FUNCTION EXAMPLE3 ()
LOCAL  Status := 0
LOCAL  a      := 0
LOCAL  b      := 0

/* ##BEGIN */
/*   MODUL=DEMO_EXAMPLE3 */
/*   PROGNO=0,MODULNR=1 */
/*   NOTURBO,NOREADCT,NOWATCHDOG,STATUS=Status */
/*   LONG a,b */
/*  */
/*   mclr */
  IF MEGALOCK0(33563337,23551) == -1
  
    MEGALOCK0(4245721) 
/*   Move (LR1,100) */
    MEGALOCK0(37760059,100) 
/*   Move (LR2,1) */
    MEGALOCK0(4216239) 
/*   Move (LR3,3) */
    MEGALOCK0(4233680) 
/*  */
/*   for  (LR4 = 0; LR4 < LR3; LR4 += 1 ) */
    MEGALOCK0(37800523,0) 
    WHILE .T.
    
      MEGALOCK0(4253277) 
      IF MEGALOCK0(4203384) <> -1
        EXIT
      ENDIF
/*     if LR4 < 2 */
      MEGALOCK0(4242566) 
      IF MEGALOCK0(4203384) == -1
      
/*       Addition (LR1,LR4) */
        MEGALOCK0(4223985) 
/*     else */

      ELSE
      
/*       Subtract (LR2,LR1) */
        MEGALOCK0(4239510) 
/*     endif */
      ENDIF
/*   next */
      MEGALOCK0(4239714) 
    END
/*  */
/*   Clear(LR1) */
    MEGALOCK0(4225435) 
/*   Move (LR0,50) */
    MEGALOCK0(37756896,50) 
/*   do */
    WHILE .T.
    
/*     Addition (LR1,a) */
      MEGALOCK0(37803831,@a) 
/*     Increment (LR2) */
      MEGALOCK0(4245190) 
/*  */
/*     if LR1 > b */
      MEGALOCK0(37756542,@b) 
      IF MEGALOCK0(4213722) == -1
      
/*       Move (LR0,1) */
        MEGALOCK0(4227379) 
/*       Getreg (a,LR1) */
        MEGALOCK0(541072044,@a) 
/*     endif */
      ENDIF
/*   loop LR0 */
      MEGALOCK0(4226473) 
      MEGALOCK0(37811676,0) 
      IF MEGALOCK0(4210886) <> -1
        EXIT
      ENDIF
    END
    MEGALOCK0(4205606) 
  ENDIF
  MEGALOCK0(813694976,@Status) 
/* ##END */
RETURN(NIL)
/********************************************************************/
